/*
Licence
-------
The code in this repository is available under the [MIT License](https://secure.wikimedia.org/wikipedia/en/wiki/Mit_license).
Copyright (c) 2008-2012 Memo Akten, [www.memo.tv](http://www.memo.tv)
The Mega Super Awesome Visuals Company
*/

//ported from c++ (ofxMSAFluid) to SuperCollider by redFrik
//press keys 1-4, d, p, r

(
//--settings
var width= 480, height= 320;//width= 960, height= 640;
var trails= 0.4;

/*var fluidCellsX= 150;//20-400*/
var colorMult= 98.5;//0-100
var velocityMult= 18.5;//0-100
var fsViscocity= 0.00015;//0-0.01
var fsColorDiffusion= 0;//0-0.0003
var fsFadeSpeed= 0.002;//0-0.1
var fsSolverIterations= 10;//1-50
var fsDeltaT= 0.5;//0.1-5
var fsDoRGB= true;//true/false
var fsDoVorticityConfinement= false;//true/false
var drawFluid= true;//true/false
var drawParticles= true;//true/false
var fsWrapX= false;//true/false
var fsWrapY= false;//true/false

//--variables
var aspectRatio= width*(1/height);
var aspectRatio2= aspectRatio*aspectRatio;
var fluidSolver= MSAFluidSolver(60, 40, iterations: fsSolverIterations);//100, 100
var fluidDrawer= MSAFluidDrawer.new.setup(fluidSolver);
var particleSystem= MSAParticleSystem1();
var rect= Rect(0, 0, width, height);
var win= Window("MSAFluidDemo", Rect(100, 30, width, height), false);
var usr= UserView(win, rect);
var gui= Window("MSAFluidDemo GUI", Rect(600, 30, 380, 240), false);
var sldColorMult= Slider(gui, Rect(10, 10, 200, 20)).value_(colorMult/100).action_({|v| colorMult= v.value*100});
var txtColorMult= StaticText(gui, Rect(220, 10, 500, 20)).string_("colorMult");
var sldVelocityMult= Slider(gui, Rect(10, 30, 200, 20)).value_(velocityMult/100).action_({|v| velocityMult= v.value*100});
var txtVelocityMult= StaticText(gui, Rect(220, 30, 500, 20)).string_("velocityMult");
var sldViscocity= Slider(gui, Rect(10, 50, 200, 20)).value_(fsViscocity/0.01).action_({|v| fluidSolver.setVisc(v.value*0.01)});
var txtViscocity= StaticText(gui, Rect(220, 50, 500, 20)).string_("Viscocity");
var sldColorDiffusion= Slider(gui, Rect(10, 70, 200, 20)).value_(fsColorDiffusion/0.0003).action_({|v| fluidSolver.setColorDiffusion(v.value*0.0003)});
var txtColorDiffusion= StaticText(gui, Rect(220, 70, 500, 20)).string_("ColorDiffusion");
var sldFadeSpeed= Slider(gui, Rect(10, 90, 200, 20)).value_(fsFadeSpeed/0.1).action_({|v| fluidSolver.setFadeSpeed(v.value*0.1)});
var txtFadeSpeed= StaticText(gui, Rect(220, 90, 500, 20)).string_("FadeSpeed");
var sldSolverIterations= Slider(gui, Rect(10, 110, 200, 20)).value_(fsSolverIterations.linlin(1, 50, 0, 1)).action_({|v| fluidSolver.setSolverIterations(v.value.linlin(0, 1, 1, 50).round.asInteger)});
var txtSolverIterations= StaticText(gui, Rect(220, 110, 500, 20)).string_("SolverIterations");
var sldDeltaT= Slider(gui, Rect(10, 130, 200, 20)).value_(fsDeltaT.linlin(0.1, 5, 0, 1)).action_({|v| fluidSolver.setDeltaT(v.value.linlin(0, 1, 0.1, 5))});
var txtDeltaT= StaticText(gui, Rect(220, 130, 500, 20)).string_("DeltaT");
var butDoRGB= Button(gui, Rect(10, 150, 200, 20)).states_([["0"],["1"]]).value_(fsDoRGB.binaryValue).action_({|v| fluidSolver.enableRGB(v.value.booleanValue)});
var txtDoRGB= StaticText(gui, Rect(220, 150, 500, 20)).string_("DoRGB");
var butDoVorticityConfinement= Button(gui, Rect(10, 170, 200, 20)).states_([["0"],["1"]]).value_(fsDoVorticityConfinement.binaryValue).action_({|v| fluidSolver.enableVorticityConfinement(v.value.booleanValue)});
var txtDoVorticityConfinement= StaticText(gui, Rect(220, 170, 500, 20)).string_("DoVorticityConfinement");
var butWrapX= Button(gui, Rect(10, 190, 200, 20)).states_([["0"],["1"]]).value_(fsWrapX.binaryValue).action_({|v| fluidSolver.setWrap(fsWrapX= v.value.booleanValue, fsWrapY)});
var txtWrapX= StaticText(gui, Rect(220, 190, 500, 20)).string_("WrapX");
var butWrapY= Button(gui, Rect(10, 210, 200, 20)).states_([["0"],["1"]]).value_(fsWrapY.binaryValue).action_({|v| fluidSolver.setWrap(fsWrapX, fsWrapY= v.value.booleanValue)});
var txtWrapY= StaticText(gui, Rect(220, 210, 500, 20)).string_("WrapY");
var pMouse= FloatArray[0, 0];
var fadeToColor= {|r, g, b, speed|
	Pen.fillColor= Color(r, g, b, speed);
	Pen.fillRect(rect);
};
var addToFluid= {|pos, vel, addColor, addForce|
	var index, drawColor;
	var speed= (vel[0]*vel[0])+(vel[1]*vel[1]*aspectRatio2);
	if(speed>0, {
		pos[0]= pos[0].clip(0, 1);
		pos[1]= pos[1].clip(0, 1);
	});
	index= fluidSolver.getIndexForPos(pos);
	if(addColor, {
		drawColor= Color.hsv(usr.frame%256/255.0, 1, 1);
		fluidSolver.addColorAtIndex(index, FloatArray[drawColor.red, drawColor.green, drawColor.blue]*colorMult);
		if(drawParticles, {
			particleSystem.addParticles(pos*FloatArray[width, height], 10);
		});
	});
	if(addForce, {
		fluidSolver.addForceAtIndex(index, vel*velocityMult);
	});
};
fluidSolver.enableRGB(fsDoRGB).setFadeSpeed(fsFadeSpeed).setDeltaT(fsDeltaT).setVisc(fsViscocity).setColorDiffusion(fsColorDiffusion);
usr.background= Color.black;
usr.clearOnRefresh= false;
usr.animate= true;
win.acceptsMouseOver= true;
usr.keyDownAction= {|view, chr|
	switch(chr,
		$1, {
			fluidDrawer.setDrawMode(\color);
		},
		$2, {
			fluidDrawer.setDrawMode(\motion);
		},
		$3, {
			fluidDrawer.setDrawMode(\speed);
		},
		$4, {
			fluidDrawer.setDrawMode(\vectors);
		},
		$d, {
			drawFluid= drawFluid.not;
		},
		$p, {
			drawParticles= drawParticles.not;
		},
		//$f, {}, //toggle fullscreen not implemented
		$r, {
			fluidSolver.reset;
		}
	);
};
usr.mouseOverAction= {|view, x, y|
	var eventPos= FloatArray[x, y];
	var mouseNorm= eventPos/FloatArray[width, height];
	var mouseVel= eventPos-pMouse/FloatArray[width, height];
	addToFluid.value(mouseNorm, mouseVel, true, true);
	pMouse= eventPos;
};
usr.mouseMoveAction= {|view, x, y|
	var eventPos= FloatArray[x, y];
	var mouseNorm= eventPos/FloatArray[width, height];
	var mouseVel= eventPos-pMouse/FloatArray[width, height];
	addToFluid.value(mouseNorm, mouseVel, false, true);
	pMouse= eventPos;
};
usr.mouseDownAction= usr.mouseMoveAction;
usr.drawFunc= {
	fluidSolver.update;
	if(drawFluid, {
		fluidDrawer.draw(0, 0, width, height);
	}, {
		fadeToColor.value(0, 0, 0, trails);
	});
	if(drawParticles, {
		particleSystem.updateAndDraw(fluidSolver, FloatArray[width, height], drawFluid);
	});
	Pen.fillColor= Color.white;
	Pen.stringAtPoint("fps:"+usr.frameRate.round(0.001), Point(5, 10));
};
//{fluidSolver.update}.bench;
gui.front;
win.front;
CmdPeriod.doOnce({win.close; gui.close});
)
