/*
Licence
-------
The code in this repository is available under the [MIT License](https://secure.wikimedia.org/wikipedia/en/wiki/Mit_license).
Copyright (c) 2008-2012 Memo Akten, [www.memo.tv](http://www.memo.tv)
The Mega Super Awesome Visuals Company
*/

//ported from c++ (ofxMSAFluid) to SuperCollider by redFrik

MSAParticle1 {
	classvar momentum= 0.5;
	classvar fluidForce= 0.6;
	classvar vmax= 0.013;
	var <pos, <vel;
	var radius;
	var <alpha= 0;
	var mass;
	var vmax2;
	init {|x, y|
		pos= FloatArray[x, y];
		vel= FloatArray[0, 0];
		radius= 5;
		alpha= rrand(0.3, 1);
		mass= rrand(0.1, 1);
		vmax2= vmax*vmax;
	}
	update {|solver, windowSize, invWindowSize|
		vel= solver.getVelocityAtPos(pos*invWindowSize)*(mass*fluidForce)*windowSize+(vel*momentum);
		if(vel[0].abs<0.001, {
			vel[0]= 0;
		});
		if(vel[1].abs<0.001, {
			vel[1]= 0;
		});
		if(vel[0]==0 and:{vel[1]==0}, {
			alpha= alpha*0.9;
		}, {
			pos= pos+vel;
			if(pos[0]<0, {
				pos[0]= 0;
				vel[0]= vel[0]* -1;
			}, {
				if(pos[0]>windowSize[0], {
					pos[0]= windowSize[0];
					vel[0]= vel[0]* -1;
				});
			});
			if(pos[1]<0, {
				pos[1]= 0;
				vel[1]= vel[1]* -1;
			}, {
				if(pos[1]>windowSize[1], {
					pos[1]= windowSize[1];
					vel[1]= vel[1]* -1;
				});
			});
		});
		// fade out a bit (and kill if alpha == 0);
		alpha= alpha*0.999;
		if(alpha<0.01, {
			alpha= 0;
		});
	}
	updateVertexArrays {|drawingFluid, invWindowSize, i|
		var points, color;
		var vxNorm, vyNorm, v2, satInc;
		points= [
			Point(pos[0]-vel[0], pos[1]-vel[1]),
			Point(pos[0], pos[1])
		];
		if(drawingFluid, {
			// if drawing fluid, draw lines as black & white
			color= Color.grey(alpha);
		}, {
			// otherwise, use color
			vxNorm= vel[0]*invWindowSize[0];
			vyNorm= vel[1]*invWindowSize[1];
			v2= ((vxNorm*vxNorm)+(vyNorm*vyNorm)).min(vmax2);
			if(mass>0.5, {
				satInc= mass*mass*mass;
				satInc= satInc*(satInc*satInc*satInc);
			}, {
				satInc= 0;
			});
			color= Color.hsv(0, v2/vmax2+satInc, mass*0.5+0.5*alpha);
		});
		^[points, color];
	}
}
