/*
Licence
-------
The code in this repository is available under the [MIT License](https://secure.wikimedia.org/wikipedia/en/wiki/Mit_license).
Copyright (c) 2008-2012 Memo Akten, [www.memo.tv](http://www.memo.tv)
The Mega Super Awesome Visuals Company
*/

//ported from c++ (ofxMSAFluid) to SuperCollider by redFrik

MSAParticleSystem1 {
	var curIndex;//Integer
	var particles;//Array

	*new {|maxParticles= 5000|
		^super.new.initMSAParticleSystem1(maxParticles);
	}
	initMSAParticleSystem1 {|argMaxParticles|
		curIndex= 0;
		particles= Array.fill(argMaxParticles, {MSAParticle1()});
	}
	updateAndDraw {|solver, windowSize, drawingFluid|
		var points, color;
		var invWindowSize= 1/windowSize;
		particles.do{|p, i|
			if(p.alpha>0, {
				p.update(solver, windowSize, invWindowSize);
				#points, color= p.updateVertexArrays(drawingFluid, invWindowSize, i);
				Pen.strokeColor= color;
				Pen.line(*points);
				Pen.stroke;
			});
		};
	}
	addParticles {|pos, count, spread= 15|
		count.do{this.addParticle(pos+[spread.rand2, spread.rand2])};
	}
	addParticle {|pos|
		particles[curIndex].init(pos[0], pos[1]);
		curIndex= curIndex+1;
		if(curIndex>=particles.size, {
			curIndex= 0;
		});
	}
}
